-- jasion_li 2021-09-02

-- truncate table t_tdm_asset_data;
-- 资产清单
IF EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 't_tccit_hjzczjtx_account')
INSERT INTO t_tdm_asset_data (fid,
							  ftaxorg, 
							  fassetcode,
							  fassetname,
							  fstartdate, 
							  fassetclass, 
							  fassetstatus, 
							  fcleaningdate, 
							  fnodepreciation, 
							  frdaddition, 
							  fenable 
							  ) 
(select a.fid, 
	   a.forgid,
	   a.fassetsnumber, 
	   a.fassetsname, 
	   a.fpostingdate, 
	   a.fzctype, 
	   a.fzcstatus, 
	   b.fcleandate, 
	   case c.fglqtnstzsx 
	   when 'syqzc' then 'assetsUseRight' 
	   when 'bzsrxcdzc' then 'noTaxIncom' 
	   else 'notApplicable' end, 
	   case c.fyfxcdwxzc 
	   when '1' then '1'
	   else '0' end,
	   case c.fenable 
	   when '1' then '1'
	   else '0' end
	   from  t_tdm_totalassets_mes a left join t_tdm_totalassets_mes_a b on a.fid = b.fid
	   left join t_tccit_hjzczjtx_account c on a.forgid = c.forgid and a.fassetsnumber = c.fassetsnumber 
	   where a.fid not in (select fid from t_tdm_asset_data));
	   
	-- truncate table t_tdm_account_depre;
-- 会计折旧	  
INSERT INTO t_tdm_account_depre (fid,
								 forg, 
								 fassetcode,
								 fassetname,
								 faccountingperiod, 
								 fassetsvalue, 
								 fresidualvalue, 
								 famortizationmethod, 
								 famortizationperiods, 
								 fcurrentamount, 
								 fyearamount, 
								 fcumulativeamount 
								 ) 
(select a.fid, 
	   a.forgid, 
	   a.fassetsnumber, 
	   a.fassetsname, 
	   a.faccountingperiod, 
	   a.fassetsvalue, 
	   a.fkjyjjcz, 
	   a.fzjtxmethod, 
	   a.fkjzjtxqs, 
	   a.fkjdqzjtxw, 
	   a.fkjbnzjtxe, 
	   a.fkjljzjtxe 
	   from  t_tdm_totalassets_mes a
	   where a.fid not in (select fid from t_tdm_account_depre));
	  
	  
-- truncate table t_tdm_tax_depreciation; 	  
-- 税务一般折旧
IF EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 't_tpo_yearitem_detail')
INSERT INTO t_tdm_tax_depreciation (fid,
									forg,
									fassetcode,
									fassetname,
									ftaxassetcategory, 
									faccountingperiod, 
									fcalctaxbase, 
									ftaxresidualvalue, 
									ftaxamortizationmethod, 
									ftaxamortizationperiods, 
									ftaxcurrentamount, 
									ftaxyearamount, 
									ftaxcumulativeamount,
									fext
									) 
(select a.fid, 
	   a.forgid, 
	   a.fassetsnumber, 
	   a.fassetsname, 
	   ' ', 
	   a.faccountingperiod, 
	   a.fcalctaxbase, 
	   a.fswyjjcz, 
	   a.fswybzjtxff, 
	   a.fswybzjtxqs, 
	   a.fswybdqzjtxe, 
	   a.fswybbnzjtxe, 
	   a.fswybljzjtxe,
	   ttydl.fprojname
	   from  t_tdm_totalassets_mes a 
	   left join t_tpo_yearitem_detail ttyd on a.ftaxassetstype = ttyd.fentryid
	   left join t_tpo_yearitem_detail_l ttydl  on ttyd.fentryid = ttydl.fentryid and ttydl.flocaleid = 'zh_CN'
	   where a.fid not in (select fid from t_tdm_tax_depreciation));

UPDATE t_tdm_tax_depreciation SET ftaxassetcategory = fext WHERE fext IS NOT NULL;
UPDATE t_tdm_tax_depreciation SET fext = '';

-- truncate table t_tdm_actual_depreciation;
-- 税务实际折旧
IF EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 't_tpo_yearitem_detail')
INSERT INTO  t_tdm_actual_depreciation	(fid,
										 forg,
										 fassetcode,
										 fassetname,
										 ftaxassetstype, 
										 facceleratedepretype, 
										 faccountingperiod, 
										 fcalctaxbase, 
										 ftaxresidualvalue, 
										 ftaxactualmethod, 
										 fintegerfield, 
										 ftaxcurrentamount, 
										 ftaxyearamount, 
										 ftaxcumulativeamount,
										 fext,
										 fext1
                                         )    
(select a.fid, 
	   a.forgid, 
	   a.fassetsnumber, 
	   a.fassetsname, 
	   ' ',
	   ' ',
	   a.faccountingperiod, 
	   a.fcalctaxbase, 
	   a.fswyjjcz, 
	   a.fswjszjtxff, 
	   a.fswjszjtxqs, 
	   a.fswjsdqzjtxe, 
	   a.fswjsbnzjtxe, 
	   a.fswjsljzjtxe,
	   ttydl.fprojname,
	   b.fjszjqc
	   from  t_tdm_totalassets_mes a 
	   left join t_tdm_totalassets_mes_a b on a.fid = b.fid 
	   left join t_tpo_yearitem_detail ttyd on a.ftaxassetstype = ttyd.fentryid
	   left join t_tpo_yearitem_detail_l ttydl  on ttyd.fentryid = ttydl.fentryid and ttydl.flocaleid = 'zh_CN' 
	   where a.fid not in (select fid from t_tdm_actual_depreciation));	 
	   
UPDATE t_tdm_actual_depreciation SET ftaxassetstype = fext WHERE fext IS NOT NULL;
UPDATE t_tdm_actual_depreciation SET facceleratedepretype = fext1 WHERE fext1 IS NOT NULL;
UPDATE t_tdm_actual_depreciation SET fext = '', fext1 = '';